Core - Feature # 47712

Status: Resolved Priority: Should have

Author: Daniel Hirtgen Category: Backend API

Created: 2013-04-29 Assigned To: Markus Klein

Updated: 2015-04-13 Due date:

PHP Version: 5.5

Complexity: hard

Sprint Focus: Remote Sprint

Subject: Refactor Locking

Description

-- to be continued --

Related issues:

related to Core - Bug # 55099: PHP Warnings after clearing configuration cach... Resolved 2014-01-17
related to Core - Bug # 66503: Core: Error handler (FE): PHP Warning: sem_get... Resolved 2015-04-20
related to Core - Bug # 55294: Under heavy load, two request can simultaneous... Closed 2014-01-24
precedes Core - Bug # 66411: New locking API exceptions too generic Resolved 2015-04-14

Associated revisions

Revision 889d9d09 - 2015-04-13 14:19 - Markus Klein

[FEATURE] Add Locking API

This patch adds a flexible locking API, which allows to be
extended by extensions.

It also deprecates the old APl and adjusts all Core usages.

Resolves: #47712

Releases: master

Change-Id: Iff144b4dd7d5d3fed357380f1669a92dece04c2¢c
Reviewed-on: http://review.typo3.0rg/37700

Reviewed-by: HelImut Hummel <helmut.hummel@typo3.org>

Tested-by: Helmut Hummel <helmut.hummel@typo3.org>

Reviewed-by: Alexander Opitz <opitz.alexander@googlemail.com>

Tested-by: Alexander Opitz <opitz.alexander@googlemail.com>

Revision f51¢1996 - 2015-04-20 23:17 - Mathias Brodala

[FOLLOWUP][TASK] Add meaningful exceptions to new locking API

This adds dedicated exceptions to the new locking API which

vastly simplifies usage workflows.

Since the new APl was not yet released, this is a non-breaking
change.

Resolves: #66411
Related: #47712
Releases: master
Change-Id: lae44eaa121562469b64222f5837f7a48e6d9fc14
Reviewed-on: http://review.typo3.org/38683

Reviewed-by: Markus Klein <klein.t3@reelworx.at>

Tested-by: Markus Klein <klein.t3@reelworx.at>

Reviewed-by: Jigal van Hemert <jigal.van.hemert@typo3.org>

Tested-by: Jigal van Hemert <jigal.van.hemert@typo3.org>

History

#1 - 2013-05-10 08:40 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.

It is available at https://review.typo3.0rg/20681

#2 - 2013-08-11 16:39 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20681

#3 - 2013-08-11 18:53 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/20681

#4 - 2013-08-28 02:45 - Ernesto Baschny

- Category changed from Code Cleanup to Backend API

Will work continue on this front? Is there a concept plan or some documentation on the end goal of this refactoring?

This is more than a "Code Cleanup", it introduces a new Locking API. So it should aim to replace the current "Locker" class. So missing still is:

1) a "flock" locking mechanism

2) make it used by the Core, making sure the old "Locker" class is not used anymore

3) deprecate the Locker class

Is it realistic that we reach the goal of finishing this API before feature freeze (which would be next week but will most probably be postponed) and that

we reach the goal of "replacing the usage of Locker" before the final release?

#5 - 2013-10-28 20:54 - Ernesto Baschny

- Target version deleted (6.2.0)

#6 - 2014-12-12 23:28 - Christian Kuhn

- Status changed from Under Review to Rejected
While the work on this is highly appreciated and the pending patch was a good step into the right direction, it was pending as WIP in gerrit for a year
now without anyone really working on it. The patch was abandoned for the time being. Meanwhile, a blueprint for locking evolved at
http://wiki.typo3.org/Blueprints/LockingForCaches and the work here is mentioned there for anyone to pick up.

This issue here will be set to "rejected" for now, since further works needs to be aligned and decided in the blueprint, and after that realized in smaller

and new issues.

#7 - 2015-03-10 13:22 - Markus Klein

- Status changed from Rejected to Accepted

- Assigned To changed from Daniel Hiirtgen to Markus Klein
- Target version set to 7.2 (Frontend)

- PHP Version changed from 5.3 to 5.5

- Complexity changed from nightmare to hard

#8 - 2015-03-10 14:24 - Gerrit Code Review

- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/37700

#9 - 2015-03-10 14:30 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0rg/37700

#10 - 2015-03-10 14:32 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0rg/37700

#11 - 2015-03-10 17:49 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/37700

#12 - 2015-03-10 18:18 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0rg/37700

#13 - 2015-03-13 01:16 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0rg/37700
#14 - 2015-03-13 01:21 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/37700

#15 - 2015-03-13 01:35 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0rg/37700

#16 - 2015-03-15 18:28 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0rg/37700

#17 - 2015-03-17 03:26 - Markus Klein

- Sprint Focus set to Remote Sprint

#18 - 2015-03-20 18:39 - Gerrit Code Review

Patch set 10 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/37700

#19 - 2015-03-25 01:05 - Gerrit Code Review

Patch set 11 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/37700

#20 - 2015-03-31 19:03 - Gerrit Code Review

Patch set 12 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/37700

#21 - 2015-04-02 00:37 - Gerrit Code Review

Patch set 13 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/37700

#22 - 2015-04-11 00:16 - Gerrit Code Review

Patch set 14 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/37700

#23 - 2015-04-13 10:13 - Gerrit Code Review
Patch set 15 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/37700

#24 - 2015-04-13 10:14 - Gerrit Code Review

Patch set 16 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/37700

#25 - 2015-04-13 11:46 - Gerrit Code Review

Patch set 17 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/37700

#26 - 2015-04-13 11:53 - Gerrit Code Review

Patch set 18 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/37700

#27 - 2015-04-13 11:57 - Gerrit Code Review

Patch set 19 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/37700

#28 - 2015-04-13 14:30 - Markus Klein
- Status changed from Under Review to Resolved
- % Done changed from 40 to 100

Applied in changeset commit:889d9d09baacdfa23aabfa0495476ec1a6f8c63a.

2015-08-04

5/5


http://review.typo3.org/37700
http://review.typo3.org/37700
http://review.typo3.org/37700
http://review.typo3.org/37700
http://review.typo3.org/37700

